/*
@copyright Louis Dionne 2014
Distributed under the Boost Software License, Version 1.0.
(See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)
 */

#include <boost/hana/functional.hpp>

#include <boost/hana/detail/static_assert.hpp>
using namespace boost::hana;


struct nonpod { virtual ~nonpod() { } };

int main() {
    BOOST_HANA_STATIC_ASSERT(always('a')() == 'a');
    BOOST_HANA_STATIC_ASSERT(always('a')(1) == 'a');
    BOOST_HANA_STATIC_ASSERT(always('a')(1, '2') == 'a');
    BOOST_HANA_STATIC_ASSERT(always('a')(1, '2', "3") == 'a');
    BOOST_HANA_STATIC_ASSERT(always('a')(1, '2', "3", 4.4f) == 'a');
    BOOST_HANA_STATIC_ASSERT(always('a')(1, '2', "3", 4.4f, nonpod{}) == 'a');
}
